workflow:
  rules:
    - if: '$CI_COMMIT_BRANCH'

variables:
  GIT_SUBMODULE_STRATEGY: normal

image: node:14.13.1-alpine3.12

before_script:
  - npm install elm@latest-0.19.1
  - mkdir build
  - if [ -d src/assets ] ; then cp -r src/assets/ build/ ; fi
  - cp src/index.html build/

build:
  script:
    - npx elm make src/Main.elm --debug --output=build/elm.js
  artifacts:
    paths:
      - build
  rules:
    - if: '$CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH'
      when: never
    - changes:
        - src/assets/**
        - src/*.elm
        - src/**/*.elm
        - .gitlab-ci.yml
        - src/index.html
      when: on_success
    - when: never

pages:
  script:
    - mv build/ public/
    - npx elm make src/Main.elm --optimize --output=public/elm.big.js
    - npm install uglify-js@3
    - cd public
    - npx uglifyjs elm.big.js --compress 'pure_funcs="F2,F3,F4,F5,F6,F7,F8,F9,A2,A3,A4,A5,A6,A7,A8,A9",pure_getters,keep_fargs=false,unsafe_comps,unsafe' | npx uglifyjs --mangle --output elm.js
    - rm elm.big.js
  artifacts:
    paths:
      - public
  rules:
    - if: '$CI_COMMIT_BRANCH != "master"'
      when: never
    - changes:
        - src/assets/**
        - src/*.elm
        - src/**/*.elm
        - .gitlab-ci.yml
        - src/index.html
      when: on_success
    - when: never
